#include <iostream.h>
#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>
#include <strings.h>

#include "Trie.h"

int schnum, insnum;
char inskeyarray[100000][32];
char schkeyarray[350000][32];

char data_[]="Hello World!";

char char2index[128];

/* PatternSize must be changed when there is any change on number of characters supported */
void ini_char2index() {
  bzero(char2index, 128);
  char i, pos=0;
  for (i='a'; i<='z'; i++)
    char2index[i]=pos++;
  /*
  for (i='A'; i<='Z'; i++)
    char2index[i]=pos++;
  */
  char2index['-']=pos++;
  char2index['\'']=pos++;
  char2index[' ']=pos++;
}

void nullprintf(FILE * fp, char *string, ...){
}

int line_size=32;

void main(int argc, char *argv[]){
  clock_t t_begin, t_end, i_begin, i_end;
  FILE *fpin=stdin, *fpout=stdout;
  char op, ch;
  dataType data;
  Trie *trie;
  int tnsize=1;		// initial trie node size
  int i;

  ini_char2index();

  while ((ch=getopt(argc, argv, "t:l:i:o:h"))!=-1) {
    switch (ch) {
    case 'i':
      fpin=fopen(optarg, "r");
      break;
    case 'l':
      line_size=atoi(optarg);
      break;
    case 'o':
      fpout=fopen(optarg, "w");
      break;
    case 't':
      tnsize=atoi(optarg);
      break;
    case 'h':
    default:
      fprintf(stderr,"usage: %s [-i <inputfile>] [-o <outputfile>] \
 [-l <cache line size>] [-t <initial trie node size>] [-h]\n", argv[0]);
      exit(0);
    }
  }

  trie=new Trie(tnsize);

  do {
    //   fprintf(stdout, "Enter operation: (i)nsert, (l)oad, (s)earch, d(u)mp or e(x)it\n");
    do {op=fgetc(fpin);} while(op==' ' || op=='\n');
    switch (op) {
    case 'i':   // Insert word x to s
        fscanf(fpin, "%s", inskeyarray[insnum]);
        insnum++;
        break;
    case 's':   // Insert word x to s
        fscanf(fpin, "%s", schkeyarray[schnum]);
        schnum++;
      break;
    case 'x':   // Exit
      break;
    }
    fflush(fpout);
  }
  while (op != 'x');

  i_begin=clock();
  for (i=0; i<insnum; i++) {
      trie->Insert(inskeyarray[i], data_);
  }
  i_end=clock();

  t_begin=clock();
  for (i=0; i<schnum; i++) {
#if 0 
    trie->Search(schkeyarray[i]);
#else
    if (data = trie->Search(schkeyarray[i])) 
      fprintf(fpout, "%s - Found: %s\n", schkeyarray[i], data);
    else
      fprintf(fpout, "%s - Not found\n", schkeyarray[i]); 
#endif
  }
  t_end=clock();

  fprintf(stdout, "The time used for insert is %ld msec\n", (i_end-i_begin)/1000);
  fprintf(stdout, "The time used for search is %ld msec\n", (t_end-t_begin)/1000);

  if (fpin!=stdin) fclose(fpin);
  if (fpout!=stdout) fclose(fpout);
}
