#include "Btree.h"

Btree::Btree(int btreearyIn, Array* a) {
  BtreeNode** bnList=new (BtreeNode*)[a->inuse+1];
  keyType* keyList=new keyType[a->inuse];
  int i, j, curSize, num=a->inuse+1;
  
  btreeary=btreearyIn;
  height=0;
  bnList[0]=(BtreeNode*)(new elementType(-1));
  for (i=0; i<a->inuse; i++)
    bnList[i+1]=(BtreeNode*)(a->elemArray+i);
  for (i=0; i<a->inuse; i++)
    keyList[i]=a->elemArray[i].key;

  while (num>1) {
    j=0;
    while (num>0) {
      curSize=num>btreeary?btreeary:num;
      bnList[j]=new BtreeNode(btreeary, bnList+j*btreeary, keyList+j*btreeary, curSize);
      num-=curSize;
      if (num>0) keyList[j]=keyList[(j+1)*btreeary-1];
      j++;
    }
    num=j;
    height++;
  }

  root=bnList[0];
  size=a->inuse+1;
}

elementType* Btree::Insert(keyType key) {
  register short i, j;
  BtreeNode** pathPtr=new (BtreeNode*)[height+1];
  short* pathInt=new short[height];
  BtreeNode* node;
  elementType* tmp;

  pathPtr[0]=root;
  for (i=0; i<height; i++) {
    j=0;
    while (j<pathPtr[i]->branch-1 && key>=pathPtr[i]->bni[j].index) j++;
    pathInt[i]=j;
    pathPtr[i+1]=pathPtr[i]->bni[j].child;
  }

  if (key==((elementType*)(pathPtr[height]))->key) 
    return (elementType*)(pathPtr[height]);

  size++;

  tmp=new elementType(key);
  node=(BtreeNode*)tmp;
  for (i=height-1; i>=0; i--) {
    if (pathPtr[i]->branch<btreeary) {
      for (j=pathPtr[i]->branch-1; j>pathInt[i]; j--) {
	pathPtr[i]->bni[j+1].child=pathPtr[i]->bni[j].child;
	pathPtr[i]->bni[j].index=pathPtr[i]->bni[j-1].index;
      }
      pathPtr[i]->bni[pathInt[i]].index=key;
      pathPtr[i]->bni[pathInt[i]+1].child=node;
      pathPtr[i]->branch++;
      break;
    }
    node=new BtreeNode(btreeary, node);
    for (j=pathInt[i]+1; j<pathPtr[i]->branch; j++)
      node->add(pathPtr[i]->bni[j-1].index, pathPtr[i]->bni[j].child);
    pathPtr[i]->branch=pathInt[i]+1;
  }
  if (i<0) {
    height++;
    root=new BtreeNode(btreeary, root);
    root->add(key, node);
  }

  delete pathPtr;
  delete pathInt;

  return tmp;
}

Boolean Btree::Delete(keyType key) {
}

elementType* Btree::Search(keyType key) {
  register short i, j;
  BtreeNode* node=root; INS_INC(2);

  for (i=0; i<height; i++) { INS_INC(5);
    j=0; INS_INC(1);
    while (j<node->branch-1 && key>=node->bni[j].index) { INS_INC(16);
      j++; INS_INC(1); INS_INC(1);
    } 
    node=node->bni[j].child; INS_INC(8);  INS_INC(3);
  }
  
  if (key==((elementType*)node)->key) {  INS_INC(8);
    INS_INC(4);
    return (elementType*)node; 
  }
  else {
    INS_INC(2);
    return NULL; 
  }
}

elementType* Btree::getFirst() {
  int i;
  for (i=0; i<height; i++) traversalInt[i]=0;
  traversalPtr[0]=root;
  for (i=1; i<height; i++) traversalPtr[i]=traversalPtr[i-1]->bni[0].child;
  return getNext();
}

elementType* Btree::getNext() {
  int i=height-1;
  traversalInt[height-1]++;
  while (i>=0 && (traversalInt[i]==traversalPtr[i]->branch)) {
    traversalInt[i]=0;
    i--;
    if (i>=0) traversalInt[i]++;
  }
  if (i<0) return NULL;
  for (int j=i+1; j<height; j++)
    traversalPtr[j]=traversalPtr[j-1]->bni[traversalInt[j-1]].child;
  return (elementType*)(traversalPtr[height-1]->bni[traversalInt[height-1]].child);
}

void BtreeNode::toHtable(HashTable* htbl, int h) {
  int i;
  elementType *et;
  if (h>0) {
    for (i=0; i<branch; i++) {
      bni[i].child->toHtable(htbl, h-1);
    }
  }
  else {
    for (i=0; i<branch; i++) {
      et=htbl->Insert(((elementType*)(bni[i].child))->key);
      et->data=((elementType*)(bni[i].child))->data;
      et->next=((elementType*)(bni[i].child))->next;
    }
  }
}
