#include <iostream.h>
#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>

#include "Trie.h"

int schnum, insnum;
keyType inskeyarray[160000][MAXLEVEL];
keyType schkeyarray[650000][MAXLEVEL];
char	inslen[160000];
char	schlen[650000];

void nullprintf(FILE * fp, char *string, ...){
}

char BtreeONLY=0, HtableONLY=0;
int arraysize=8;
int btreeheight=4;
int btreenodesize=8;
int bucketsize=8;
int numbucket=1024;
int line_size=32;

void main(int argc, char *argv[]){
  clock_t i_begin, i_end, t_begin, t_end;
  FILE *fpin=stdin, *fpout=stdout;
  char op, ch, *next;
  dataType *dataPtr;
  keyType keyarray[32];
  dataType data=1;
  int keylen;
  Trie *trie;
  int i;

  while ((ch=getopt(argc, argv, "t:n:k:l:i:o:a:b:hBH"))!=-1) {
    switch (ch) {
    case 'a':
      arraysize=atoi(optarg);
      break;
    case 'b':
      btreenodesize=atoi(optarg);
      break;
    case 'H':
      HtableONLY=1;
      break;
    case 'B':
      BtreeONLY=1;
      break;
    case 'i':
      fpin=fopen(optarg, "r");
      break;
    case 'k':
      bucketsize=atoi(optarg);
      break;
    case 'l':
      line_size=atoi(optarg);
      break;
    case 'n':
      numbucket=atoi(optarg);
      break;
    case 'o':
      fpout=fopen(optarg, "w");
      break;
    case 't':
      btreeheight=atoi(optarg);
      break;
    case 'h':
    default:
      fprintf(stderr,"usage: %s [-i <inputfile>] [-o outputfile>] \
 [-a maxelem_in_array] [-b maxelem_inbtreenode] \
 [-t btreeheight] [-k bucketsize] [-n numbucket]\
 [-l cache line size] [-h] [-B] [-H]\n", argv[0]);
      exit(0);
    }
  }

  arraysize=4*line_size/sizeof(elementType);
  btreeheight=4;
  btreenodesize=line_size/8;
  bucketsize=line_size/6-1;
  numbucket=1024;

  trie=new Trie(arraysize, btreenodesize, btreeheight,bucketsize, numbucket);

  do {
    //   fprintf(stdout, "Enter operation: (i)nsert, (l)oad, (s)earch, d(u)mp or e(x)it\n");
    do {op=fgetc(fpin);} while(op==' ' || op=='\n');
    switch (op) {
    case 'i':	// Insert word x to s
      inslen[insnum]=0;
      do {
	fscanf(fpin, "%d", &(inskeyarray[insnum][inslen[insnum]++]));
      } while (inskeyarray[insnum][inslen[insnum]-1]!=-1);
      inslen[insnum]--;
      if (inslen[insnum]>MAXLEVEL) {
          inslen[insnum]=MAXLEVEL;
      }
      insnum++;
      
      break;
    case 's':	// Insert word x to s
      schlen[schnum]=0;
      do {
	fscanf(fpin, "%d", &(schkeyarray[schnum][schlen[schnum]++]));
      } while (schkeyarray[schnum][schlen[schnum]-1]!=-1);
      schlen[schnum]--;
      if (schlen[insnum]>MAXLEVEL) {
          schlen[insnum]=MAXLEVEL;
      }
      schnum++;
      break;

    case 'x':	// Exit
      break;
    }
  } while (op != 'x');

  i_begin=clock();
  for (i=0; i<insnum; i++) {
    trie->Insert(inslen[i], inskeyarray[i], data);
  }
  i_end=clock();

  t_begin=clock();
  for (i=0; i<schnum; i++) {
#if 0 
    trie->Search(schlen[i], schkeyarray[i]);
#else
    if (dataPtr = trie->Search(schlen[i], schkeyarray[i]))
      fprintf(fpout, "Found: %d\n", *dataPtr);
    else
      fprintf(fpout, "Not found\n");
#endif
  }
  t_end=clock();

  fprintf(stdout, "The time used for insert is %ld msec\n", (i_end-i_begin)/1000);
  fprintf(stdout, "The time used for search is %ld msec\n", (t_end-t_begin)/1000);

  if (fpin!=stdin) fclose(fpin);
  if (fpout!=stdout) fclose(fpout);
}
